#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;
typedef pair<ll,ll> pll;
const ll DIM = 1e5+7;

ll n,a[DIM],q;
string s;


int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i=1;i<=n;i++){
        cin >> a[i];
    }

    vector<pll> ans;
    for(ll i=1;i<=n;i++){
        for(ll j=i;j<=n;j++){
            if(a[j]==i || i!=j){
                ans.push_back({i,j});
                reverse(a+i,a+j+1);
            }
        }
    }

    cout << ans.size() << endl;
    for(auto [to,e]:ans)
        cout << to << ' ' << e << endl;

    return 0;
}
